﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Grid.Grouping
Imports Syncfusion.Grouping
Imports Syncfusion.Windows.Forms.Grid


Namespace DataGrid
	Partial Public Class Form1
		Inherits Form
		Private dataSet As DataSet
		Public Sub New()
			InitializeComponent()
			dataSet = New DataSet()

'			#Region "Initial DataSource"
			Me.CreateTable()
			Me.gridGroupingControl1.DataSource = Me.GGC1Table
'			#End Region

'			#Region "Cutomization"
			Me.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = False
'			#End Region
		End Sub

		#Region "Properties"
		'These properties are used to maintain the DataSource
		Private _GGC1Table As DataTable
		Public Property GGC1Table() As DataTable
			Get
				Return _GGC1Table
			End Get
			Set(ByVal value As DataTable)
				_GGC1Table = value
			End Set
		End Property

		Private _GGC2Table As DataTable
		Public Property GGC2Table() As DataTable
			Get
				Return _GGC2Table
			End Get
			Set(ByVal value As DataTable)
				_GGC2Table = value
			End Set
		End Property
		#End Region

		#Region "Initial DataSource"
		''' <summary>
		''' Default datasource
		''' </summary>
		Private Sub CreateTable()
			ReadXml(dataSet, "GDBDdata.XML")
			Me.gridGroupingControl1.DataSource = dataSet.Tables("Products")
			Me.GGC1Table = dataSet.Tables("Products")

		End Sub
		#End Region

		Private Sub ReadXml(ByVal ds As DataSet, ByVal xmlFileName As String)
			For n As Integer = 0 To 9
				If System.IO.File.Exists(xmlFileName) Then
					ds.ReadXml(xmlFileName)
					Exit For
				End If
				xmlFileName = "..\" & xmlFileName
			Next n
		End Sub

		#Region "Transpose DataSource"
		''' <summary>
		''' Used to tranpose the grid datasource
		''' </summary>
		Private Sub CreateTable2()
			'Creating the Temporary DataTable
			Dim _GdcTable As New DataTable()

			'Creating the columns 
			For i As Integer = 0 To Me.GGC1Table.Rows.Count - 1
				_GdcTable.Columns.Add("Sample" & i)
			Next i

			'Generating the data for transposed grid.
			For Each column As GridColumnDescriptor In Me.gridGroupingControl1.TableDescriptor.Columns
				Dim dr As DataRow = _GdcTable.NewRow()
				For Each record As Record In Me.gridGroupingControl1.Table.Records
					dr(Me.gridGroupingControl1.Table.Records.IndexOf(record)) = record.GetValue(column.Name).ToString()
				Next record
				_GdcTable.Rows.Add(dr)
			Next column

			'Assigning the datasource
			Me._GGC2Table = _GdcTable
		End Sub
		#End Region

		Private Sub transposeBtn_Click(ByVal sender As Object, ByVal e As EventArgs) Handles transposeBtn.Click
			Me.gridGroupingControl1.ShowColumnHeaders = False

			'To set the RowHeader cellvalues as column names
			AddHandler gridGroupingControl1.QueryCellStyleInfo, AddressOf gridGroupingControl1_QueryCellStyleInfo

			'Generating the DataSource (Transposing the DataSource)
			Me.CreateTable2()

			'Assigning the Transposed datasource
			Me.gridGroupingControl1.DataSource = Me._GGC2Table

			Me.gridGroupingControl1.Table.DefaultRowHeaderWidth = 120

		End Sub

		Private Sub gridGroupingControl1_QueryCellStyleInfo(ByVal sender As Object, ByVal e As GridTableCellStyleInfoEventArgs)

			If e.TableCellIdentity Is Nothing Then
				Return
			End If

			If e.TableCellIdentity.TableCellType = GridTableCellType.AlternateRecordRowHeaderCell OrElse e.TableCellIdentity.TableCellType = GridTableCellType.RecordRowHeaderCell Then
				e.Style.CellType = "Header"
				e.Style.CellValue = Me.GGC1Table.Columns(e.TableCellIdentity.RowIndex - 2).ColumnName
				e.Style.Font.Bold = True
			End If
		End Sub
	End Class
End Namespace
